###############################################################################
#                                  ToBylib                                    #
###############################################################################


##Icitte, on a plein de petites (ou grandes) fonctions ou classes, qui sont
##utilisées par ToBybuR<.
##Elle sont utiles à la fois pour les modules et pour le cœur du bot.
##
##Je ne sais pas si c'est vraiment utile d'avoir un fichier à part pour ça, mais
##ça rend la lecture du code principal plus claire.

##une petite fonction pour logger:
def log(msg)
  threadname = Thread.current[:name]
  threadname = "unknown thread" if threadname == nil
  $logfile << Time.now.to_s + '@' + threadname + " : " + msg.to_s + "\n"
  $logfile.flush
end

##L'objet module contient: fichier, nom, statut (on/off), whitelistage, anonyme authorisé, config (xml) et params
class Greffon
  attr_reader :nom, :fichier, :statut, :whitelist, :anonyme, :config
  attr_accessor :params
  def initialize(conf)
    @fichier = conf.attributes["name"]
    if conf.attributes["id"] != nil
      @nom = @fichier + "$" + conf.attributes["id"]
    else
      @nom = @fichier
    end
    @statut = conf.attributes["statut"]
    @whitelist = conf.attributes["whitelist"]
    @anonyme = true
    if conf.attributes["anonyme"] == "false"
      @anonyme = false
    end
    @config = conf
    @params = Hash.new
  end
end

##Ça c'est la config du bot lui-même (rien de spécifique aux tribunes)
class Config
  attr_reader :useragent, :db_name, :db_driver, :db_host, :db_login, :db_pass, :db_glob_prefix, :time_zone, :tribune_list, :file_time, :naissance
  def initialize(conf_file)
    ##ça, c'est l'heure à laquelle le programme a été lancé
    @naissance = Time.now
    self.read_conf(conf_file)
  end

  def read_conf(conf_file)
    log("Chargement de " + conf_file)
    conf= Document.new(File.read(conf_file))
    @useragent = conf.elements["config/useragent"].text
    @db_name = conf.elements["config/database"].attributes["name"]
    @db_driver = conf.elements["config/database/driver"].text
    @db_host = conf.elements["config/database/host"].text
    @db_login = conf.elements["config/database/login"].text
    @db_pass = conf.elements["config/database/pass"].text
    @db_glob_prefix = conf.elements["config/database/prefix"].text
    @time_zone = conf.elements["config/time_zone"].text
    @tribune_list = Hash.new
    conf.each_element("config/tribune"){|e|
      if e.attributes["statut"] == "on"
        @tribune_list[e.attributes["name"]]=e
      end
    }
    @file_time = File.ctime(conf_file)
  end
end


##On définit une classe contenant les éléments de configuration d'un bouchot.
##Le fichiers de configuration doivent être conformes à cette norme :
##http://tifauv.homeip.net/koinkoin/dist/bouchot-config.xsd

class Tribune
  attr_reader :conf, :nom, :db_prefix, :admin_login, :time_zone, :are_tags_encoded, :modules_liste, :modules_prets
  attr_reader :peut_poster, :baseurl, :cookie, :cookie_list, :login_string, :login_page, :login_method, :backend, :refresh, :post_url, :post_format, :anonymous, :anon_name, :replace_anon
  attr_reader :webroot, :webdir, :email, :htpasswd
  attr_accessor :last_modified, :time1, :time2, :doublon, :last_post, :current_post, :current_mod
  def initialize(tribune_conf)
    @missing_config_file = false
    @conf = tribune_conf
    self.load_gen_conf(tribune_conf)
    self.load_tribune_conf(@nom)
    log("Configuration chargée.")

    @modules_prets = Hash.new
    self.create_blacklist(nil)

    self.get_cookies() if @peut_poster == "true"
  end

  def reload_conf(tribune_conf)
    @conf = tribune_conf
    self.load_gen_conf(tribune_conf)
    self.load_tribune_conf(@nom)
    log("Configuration re-chargée.")

    self.load_modules()
    log("Tribune prête.")
  end

  def prepare()
    ##on initialise quelques variables qui seront utiles:
    ##ça c'est la date de dernière modif du bouchot (pour éviter les téléchargements inutiles)
    @last_modified = ""

    ##ça, c'est pour rajouter les ¹,²,³,etc. et pour accepter les nhorloges du types 14:00 (chotomie) quand il n'y a eu qu'un post à cette minute
    @time1=""
    @time2=""
    @doublon=0
    
    ##et enfin l'id du dernier post que l'on a pris en compte
    @last_post = dbh("select_one", "SELECT MAX(post_id) FROM #{@db_prefix}posts" )[0]
    if @last_post == nil ; @last_post = 0 ; end
    log("Tribune prête.")
  end
  
  ##on lit les paramètres spécifiques à cette tribune dans le fichier de config général
  def load_gen_conf(tribune_conf)
    @nom = tribune_conf.attributes["name"]
    @db_prefix = $config.db_glob_prefix.to_s + tribune_conf.elements["db_prefix"].text
    @peut_poster = tribune_conf.elements["peut_poster"].text
    @admin_login = tribune_conf.elements["admin_login"].text
    @time_zone = tribune_conf.elements["time_zone"].text
    anon_name_elt = tribune_conf.elements["anon_name"]
    if anon_name_elt == nil
      @anon_name = "une moule anonyme"
    else
      @anon_name = anon_name_elt.text
    end
    @replace_anon = tribune_conf.elements["replace_anon"]
    if @replace_anon != nil
      @replace_anon = @replace_anon.text
    end
    @bot_login = tribune_conf.elements["bot_login"].text
    @bot_password = tribune_conf.elements["bot_password"].text
    @webroot = tribune_conf.elements["website/root"].text
    @webdir = tribune_conf.elements["website/dir"].text
    @email = tribune_conf.elements["website/email"].text
    @htpasswd = tribune_conf.elements["website/htpasswd"].text
  end

  ##puis on lit la config de la tribune dans le fichier à part
  def load_tribune_conf(tribune_name)
    if not File.exists?(tribune_name + ".config")
      log("ATTENTION : le fichier " + tribune_name + ".config n'existe pas... Je ne peux donc pas traiter cette tribune.")
      $config.tribune_list.delete(tribune_name)
      Thread.current.exit
    end
    conf = Document.new(File.read(tribune_name + ".config"))
    @baseurl = conf.elements["site"].attributes["baseurl"].gsub(/^https?:\/\//,"")
    @login_string = ""
    conf.each_element("site/account/login/field"){|e| @login_string += e.attributes["name"] + "=" + e.text + "&"}
    @login_string.gsub!("$l", @bot_login).gsub!("$p", @bot_password).chop!
    @login_page = conf.elements["site/account/login"].attributes["path"]
    @login_method = conf.elements["site/account/login"].attributes["method"]
    @backend = conf.elements["site/board/backend"].attributes["path"]
    @refresh = conf.elements["site/board/backend"].attributes["refresh"].to_i
    @post_url = conf.elements["site/board/post"].attributes["path"]
    @post_format = ""
    conf.elements["site/board/post"].each_element("field") { |c| @post_format += c.attributes["name"] + "=" + c.text + "&" }
    @post_format.gsub!(/\$m/,"%s").chop!
    @anonymous = conf.elements["site/board/post"].attributes["anonymous"]
    @cookie_list = []
    conf.elements["site/account"].each_element("cookie"){|c| @cookie_list << c.attributes["name"]}
    @cookie=""
    @are_tags_encoded = conf.elements["site/board/backend"].attributes["tags_encoded"].==("true")
  end
 
  def load_modules()
    ##C'est un peu gore ici. En fait, le problème c'est que les modules doivent être
    ##(dé)branchables à chaud, et qu'on peut changer l'ordre de chargement, mais aussi
    ##qu'il doivent être initialisés avant la première utilisation.
    ##On a donc 2 choses: une liste (ordonnée) des modules actifs, et un hash des modules
    ##initialisés (et comme il fallait mettre qqch dedans, j'ai mis l'indice du module dans
    ##la liste)
    ##À chaque fois qu'on ajoute un module à la liste, on l'initialise si besoin est.
    @modules_liste = []
    @conf.each_element("module[@statut='on']"){|e|
      mod = Greffon.new(e)
      ##on vérifie que le module n'a pas déjà été défini, si c'est le cas, on insulte l'utilisateur.
      bad_mod = false
      @modules_liste.each{|prev|
        if prev.nom == mod.nom
          log("Le module " + mod.nom + " a déjà été défini, si vous voulez avoir plusieurs instances d'un même module, veillez à ce qu'ils aient un attribut 'id' différent. Veuillez corriger le fichier de configuration.")
          bad_mod = true
        end
      }

      if bad_mod != true
        @modules_liste+= [mod]
        if @modules_prets[mod.nom] == nil
          if File.exists?("modules/" + mod.fichier + ".db.rb")
            load "modules/" + mod.fichier + ".db.rb"
          end
          create_blacklist(mod)
        end
        @modules_prets[mod.nom]=@modules_liste.size.-(1)
      end
    }
    log("Modules prêts.")
  end

  def create_blacklist(mod)
    ##ici, on ajoute la colonne appropriée à la table blacklist (si nécessaire)
    ##si mod==nil, on créé simplement la table
    if mod == nil
      dbh("do", "CREATE TABLE IF NOT EXISTS #{@db_prefix}blacklist (login VARCHAR(64), PRIMARY KEY(login) )")
    else
      begin
        $dbh.do("ALTER TABLE #{@db_prefix}blacklist ADD COLUMN #{mod.nom} TINYINT(2) DEFAULT 0")
      rescue DBI::DatabaseError => dberr
        if dberr.err != 1060 ##il n'y a pas de "IF NOT EXISTS" pour les colonnes, donc on ignore l'erreur ici
          log("Erreur dbh: #{dberr.errstr}, tentative de reconnection")
          reconnect(dberr)
          retry
        end
      end
      #et on blacklist les anonymes on fonction de la conf du module
      if mod.anonyme == false
        dbh("do", "INSERT INTO #{@db_prefix}blacklist (login, #{mod.nom}) VALUES (?,?) ON DUPLICATE KEY UPDATE #{mod.nom} = VALUES(#{mod.nom})", "", 1)  
      end
    end

  end


  ##Et ça, ça obtient les cookies grâce au login/passwd
  def get_cookies()
    @cookie=""
    h = Net::HTTP.new(@baseurl, 80)
    if @login_method == "drupal"
      data = h.get(@login_page)
      @cookie = data["set-cookie"]
      headers = {
        'User-Agent' => $config.useragent,
        'Content-type' => 'application/x-www-form-urlencoded'
      }
      headers['Cookie'] = @cookie

      data = h.post(@login_page, @login_string, headers)
      if data["set-cookie"].nil?
        log("Échec de l'authentification... Mauvais mot de passe ?")
      else
        @cookie = data["set-cookie"].split(",")[2..3].join(",")
        headers['Cookie'] = @cookie
        data = h.get(@login_page, headers)
        log("Authentification résussie ! On a un nouveau biscuit ! ")
      end
    else
      data = h.post(@login_page, @login_string)
      if data["set-cookie"].nil?
        log("Échec de l'authentification... Mauvais mot de passe ?")
      else
        @cookie_list.each{|c| @cookie += data["set-cookie"].scan(/(#{c}=\w+)/).to_s + ";" }
        @cookie.chop!
        log("Authentification résussie ! On a un nouveau biscuit ! ")
      end
    end
  end
end



##Cette fonction créé une nouvelle connection a la base de donnée.
##Le handler associé est $dbh, c'est une variable globale, çaipabien
##Il retourne un objet DBI::DatabaseError quoi qu'il arrive (avec un code 
##0, "Success" si tout s'est bien passé
def db_connect()
  begin
    $dbh = DBI.connect("DBI:" + $config.db_driver + ":" + $config.db_name + ":" + $config.db_host, $config.db_login, $config.db_pass)
    $dbh.do("set time_zone = ?", $config.time_zone)
    log("Nouvelle conection à la base.")
    DBI::DatabaseError.new("Success", 0, 0)
  rescue DBI::DatabaseError => dberr
    log("Une erreur s'est produite: Error code: #{dberr.err}, Error message: #{dberr.errstr}")
    return dberr
  end
end

  
##une petite fonction pour se reconnecter à la base si la connection est perdue
def reconnect(dberr)
  if dberr.to_s.scan("MySQL server has gone away").size == 1 or dberr.to_s.scan("Lost connection to MySQL server during query").size == 1
    begin
      log("la connection à la base est partite, on se reconnecte...")
      db_connect()
    rescue DBI::DatabaseError => dberr
      log("Une erreur s'est produite: Error code: #{dberr.err}, Error message: #{dberr.errstr}")
      log("On ré-essaie dans 10 secondes")
      sleep 10
      retry
    end
  elsif dberr.to_s.scan("Server shutdown in progress").size == 1
      log("Le serveur MySQL est en cours de redémarrage. On attend 10 secondes, et on se reconnecte")
      sleep 10
    begin
      db_connect()
    rescue DBI::DatabaseError => dberr
      log("Ça n'a pas marché: Error code: #{dberr.err}, Error message: #{dberr.errstr}")
      log("On ré-essaie dans 10 secondes")
      sleep 10
      retry
    end
  else
    log("Je ne sais pas quoi faire avec ce genre d'erreur MySQL, je me petit-suicide donc...")
    Thread.current.exit
  end
end

def dbh(type, db_str, *args)
  begin
    case type
    when "do"
      retval = $dbh.do(db_str,*args)
    when "select_all"
      retval = $dbh.select_all(db_str,*args)
    when "select_one"
      retval = $dbh.select_one(db_str,*args)
    else
      log("ATTENTION : on a demandé à dbh de faire ça, mais il ne sait pas comment, il a donc tué le thread :" + db_str + args.join(", ") )
      Thread.current.kill
      retval = nil
    end
  rescue DBI::DatabaseError => dberr
    log("Erreur dbh: #{dberr.errstr}, tentative de reconnection")
    reconnect(dberr)
    retry
  end
  
  return retval
end

##une petite classe qui nous renvoie des infos sur le post
class Poste
  attr_reader :timestamp, :date, :timestamp_Time, :pretty_date, :message, :login, :login_str, :nhorloge, :ua, :post_id, :post_xml, :doublon, :nhorloge2, :premier_doublon, :post_seul
  def initialize(tribune, post)
    @post_seul = nil
    @premier_doublon = nil
    @post_xml = post
    @timestamp = post.attributes["time"]
    @date = @timestamp[0..7]
    @timestamp_Time = Time.parse(@timestamp)
    @pretty_date = @timestamp_Time.strftime("%d/%m/%Y %H:%M:%S")
    if tribune.are_tags_encoded
      @message = post.elements["message"].text.sub(/^\n\t/,"").sub(/ $/,"")
      #encore pour corriger le sale slip de DLFP...
    else
      @message = XPath.match(post.elements["message"], "child::node()").join
    end
    @login = post.elements["login"].text
    if @login.nil? || (tribune.replace_anon != nil and @login == tribune.replace_anon)
      @login=""
    end
    if @login==""
      @login_str = tribune.anon_name
    else
      @login_str = @login
    end
    @nhorloge = @timestamp_Time.strftime("%H:%M:%S")
    @ua = post.elements["info"].text
    @post_id = post.attributes["id"]

    ##on regarde s'il faut un ¹,²,³,...
    if @timestamp == tribune.time1
      if tribune.doublon == 0
        tribune.doublon = 1 
        @premier_doublon = tribune.last_post
      end
      tribune.doublon += 1
    else
      tribune.doublon = 0
    end
    self.set_doublon(tribune.doublon)

    ##si le post précédent est le seul post de la minute, on l'indique
    if ( @timestamp[0..11] != tribune.time1[0..11] and tribune.time1[0..11] != tribune.time2[0..11] )
      @post_seul = tribune.last_post
    else
      @post_seul = nil
    end

    tribune.time2 = tribune.time1
    tribune.time1 = @timestamp
  end

  def set_doublon(d)
    @doublon = d
    if ( d == 0 )
      @nhorloge2 = @nhorloge + "¹"
    elsif ( d == 2 )
      @nhorloge2 = @nhorloge + "²"
    elsif ( d == 3 )
      @nhorloge2 = @nhorloge + "³"
    else
      @nhorloge2 = @nhorloge + ":" + d.to_s
    end
  end
end

##on se définit une petite fonction pour poster sur la tribune
##num_essai est une gruiiikerie pour ne pas tourner en boucle si ça foire tout le temps
def envoi(tribune, msg, num_essai=0)
  if tribune.peut_poster != "true"
    log("Envoi désactivé sur cette tribune. Le message aurait dû être : " + msg)
    return nil
  end
  begin
    tribune.get_cookies() if tribune.cookie == ""
    h = Net::HTTP.start(tribune.baseurl)
    h.read_timeout = 30
    headers = {
      'User-Agent' => $config.useragent,
      'Content-type'=>'application/x-www-form-urlencoded'
    }
    headers['Cookie'] = tribune.cookie

    resp = h.post(
                  tribune.post_url,
                  sprintf(tribune.post_format, msg),
                  headers
                 )
    h.finish

    ##d'après LLG<, ça juste marche, donc pas besoin de vérifier...
    ##pareil chez euroxers<. Il n'y a donc que DLFP qui pose des problèmes:
    ##
    ##empiriquement, DLFP renvoie un 302 si ça a marché, et un 200 si le cookie est pourri ou qu'on avait déjà posté moins de 11s avant
    if tribune.nom != "dlfp"
      log("Message envoyé: " + msg)
    else
      if resp.code == "302"
        log("Message envoyé: " + msg)
      elsif resp.code == "200"
        ##si c'est le coup des 10 secondes, on attend 10 secondes et on reposte
        if resp.body.include?("vous ne pouvez pas saisir un nouveau message, revenez plus tar")
          if num_essai == 0
            log("On a déjà posté il y pas longtemps, on attend 10 secondes")
            sleep 10
            envoi(tribune, msg, 1)
          else
            log("Ça rate encore (revenez plus tard), je ne sais pas pourquoi, mais je n'insiste pas...")
            log("Le postage de " + msg + " a échoué")
          end
        ##si c'est le cookie pourri, on essaie de le remplacer
        elsif resp.body.include?("et avoir un karma sup")
          if num_essai == 0
            log("Le cookie a l'air d'être périmé, j'essai d'en obtenir un autre...")
            $tribune[Thread.current[:name]].get_cookies()
            if $tribune[Thread.current[:name]].cookie != nil
              log("On ré-eassie")
              envoi(tribune, msg, 1)
            else
              log("Le postage de " + msg + " a échoué")
            end
          else
            log("Ça rate encore (karma), je ne sais pas pourquoi, mais je n'insiste pas...")
            log("Le postage de " + msg + " a échoué")
          end
        ##sinon
        else
          log("Je me suis pris un code 200 inconnu!")
          text_code200 = File::open('code200_' + Time.now.strftime("%Y%m%d%H%M%S") + '.txt', 'w')
          text_code200 << resp.body
          text_code200.close
          log("Le postage de " + msg + " a échoué")
        end
      else
        log("Le postage de " + msg + " a échoué, regarde le fichier de log pour en savoir plus...")
        text_code200 = File::open('codeinconnu_' + Time.now.strftime("%Y%m%d%H%M%S") + '.txt', 'w')
        text_code200 << resp.body
        text_code200.close
      end
    end ##fin de toute la prise de tête DLFPienne
    
  rescue
    log("Le postage de " + msg + "a échoué: #{$!}")
  end
end


##une jolie fonction qui retourne l'id (/!\ pas le post_id) du poste correspondant à 'nhorloge'
##il peut y avoir plusieurs id pour une seul nhorloge
##le timestamp sert à déterminer la date
def nhorloge2post(tribune, nhorloge, timestamp)
  timestamp_Time = Time.parse(timestamp)
  
  nhorloge_regexp = Regexp.new("^(((0[1-9])|(1[0-2]))/((0[1-9])|([1-2][0-9])|(3[0-1]))#)?(([0-1][0-9])|(2[0-3])):([0-5][0-9])(:([0-5][0-9])(&sup1;|&sup2;|&sup3;|¹|²|³|\\\^[1-9]|:[1-9])?)?")

  ##on traie la nhorloge pour en extraire les substantifiques informations
  ##(après avoir vérifié que c'était bien une nhorloge, sinon on renvoie une liste vide)
  hms = nhorloge.to_s.scan(nhorloge_regexp)[0]
  if hms == nil
    []
  else
    mois = hms[1]
    jour = hms[4]
    heure = hms[8]
    minute = hms[11]
    seconde = hms[13]
    if seconde == nil
      seconde = "00"
      seul = 1
    else
      seul = 0
    end

    doublon = hms[14]
    if doublon != nil
      doublon = hms[14].delete("^").delete("&sup").delete(";").delete(":").sub("¹","1").sub("²","2").sub("³","3")
    else
      doublon = 0
    end

    ##si la date n'est pas précisée, et que la nhorloge donnée est supérieure à l'heure du post, on suppose que c'était hier
    if mois.to_s + jour.to_s == ""
      if (heure + minute + seconde).to_i > timestamp[8..15].to_i
        date = timestamp_Time.-(24*3600).strftime("%Y-%m-%d")
      else
        date = timestamp_Time.strftime("%Y-%m-%d")
      end
    else
      ##si le mois est supérieur au mois en cours, on suppose que c'était l'année dernière
      if mois.to_i > timestamp[4..5].to_i
        annee = timestamp[0..3].to_i.-(1).to_s
      else
        annee = timestamp[0..3]
      end
      date = annee + "-" + mois.to_s + "-" + jour.to_s
    end

    ##et on interroge la base pour avoir l'id du post.
    ##si les minutes ont été omises, c'est que c'est un post "seul", ou qu'on doit inclure tous les posts
    if seul == 1
      postid = dbh("select_all", "SELECT id FROM #{tribune.db_prefix}posts WHERE date_format(post_time,'%Y-%m-%d %H:%i') = ?", date + " " + heure + ":" + minute)

    ##si doublon est à 0, c'est soit que c'est un effectivement un post sans doublon
    ##soit que la moule est une feignasse, et donc qu'on doit inclure tous les posts
    elsif doublon == 0
      postid = dbh("select_all", "SELECT id FROM #{tribune.db_prefix}posts WHERE post_time = ?", date + " " + heure + ":" + minute + ":" + seconde)

    else
      postid = dbh("select_all", "SELECT id FROM #{tribune.db_prefix}posts WHERE post_time = ? AND doublon = ?", date + " " + heure + ":" + minute + ":" + seconde, doublon)
    end

    return postid

  end

end


##cette fonction va chercher le remote.xml, et renvoie l'object REXML correspondant
def get_board(config, tribune)
  begin
    ##on contacte le serveur
    h = Net::HTTP.start(tribune.baseurl)
    h.read_timeout = 30
    data = h.get(tribune.backend, {
      'User-Agent' => config.useragent,
      'If-Modified-Since' => tribune.last_modified
    })

    ##si la page a été modifiée, on stocke la date de dernière modification,
    ##sinon, on attend "refresh" secondes, et on recommence la boucle.
    if data.class == Net::HTTPNotModified
      board = nil
    else
      tribune.last_modified = data['Last-Modified'] if data['Last-Modified'] != nil
      board = REXML::Document.new(data.body.sub("encoding=\"utf-8\"","encoding=\"UTF-8\"").gsub("</message>"," </message>"))
      ##les 2 gsub sont là pour corriger des bugs dans le slip de DLFP, mais ils ne peuvent pas faire de mal de toutes façons...
    end
    h.finish

  rescue Timeout::Error
    log("Timeout error dans le récupérage du backend: #{$!}")
    retry
  rescue
    log("Le récupérage du backend a échoué: #{$!}")
    sleep tribune.refresh
    retry
  end

  ##On a enfin notre belle tribune...
  return board
end

