my_tribune=$tribune[Thread.current[:name]]
my_post=my_tribune.current_post

###############################################################################
#                                    CPS                                      #
###############################################################################

##on s'occupe du cps
cps_regexp = Regexp.new('cps:(-?\d+(\.\d+)?):(-?\d+(\.\d+)?)')

##si l'ua a un tag cps, on le traite
if my_post.ua != nil ; coord = my_post.ua.scan(cps_regexp)[0] ; end
if coord != nil
  latitude = coord[0]
  longitude = coord[2]

  ##on ne fait rien si les coordonnées n'ont pas changé  
  vieilles_coords = dbh("select_one","SELECT longitude, latitude FROM #{my_tribune.db_prefix}cps WHERE login = ?", my_post.login)
  if vieilles_coords == nil || (vieilles_coords[:longitude].to_f != longitude.to_f || vieilles_coords[:latitude].to_f != latitude.to_f) 
  
    ##si la moule est déjà dans la base, on met à jour ses coordonnées, sinon, on l'ajoute
    dbh("do","INSERT INTO #{my_tribune.db_prefix}cps (login,latitude,longitude) VALUES (?,?,?) ON DUPLICATE KEY UPDATE latitude=VALUES(latitude) , longitude=VALUES(longitude) ", my_post.login, latitude.to_f, longitude.to_f)

    ##et on enregistre le fichier de cps, au format KML (GoogleEarth)
    cps_kml = REXML::Document.new('<?xml version="1.0" encoding="UTF-8"?>')
    cps_kml.add_element("kml", {"xmlns" => "http://earth.google.com/kml/2.0"})
    cps_kml.elements["kml"].add_element("Folder")
    cps_kml.elements["kml/Folder"].add_element("name").text="Moules"
    cps_kml.elements["kml/Folder"].add_element("visibility").text="1"
    cps_kml.elements["kml/Folder"].add_element("LookAt").add_element("longitude").text="2"
    cps_kml.elements["kml/Folder/LookAt"].add_element("latitude").text="48"
    cps_kml.elements["kml/Folder/LookAt"].add_element("range").text="5000"
    cps_kml.elements["kml/Folder/LookAt"].add_element("tilt").text="0"
    cps_kml.elements["kml/Folder/LookAt"].add_element("heading").text="0"

    liste_cps = dbh("select_all","SELECT login, longitude, latitude FROM #{my_tribune.db_prefix}cps ORDER BY login")

    liste_cps.each{|e|
      cps = Element.new("Placemark")
      cps.add_element("name").text = e[:login]
      cps.add_element("visibility").text = 1
      cps.add_element("styleUrl").text = "#khStyle652"
      cps.add_element("Point").add_element("extrude").text = 1
      cps.elements["Point"].add_element("altitudeMode").text = "relativeToGround"
      cps.elements["Point"].add_element("coordinates").text = e[:longitude] + "," + e[:latitude]
      cps_kml.elements["kml/Folder"] << cps
    }

    cps_file = File::open(my_tribune.webdir + "cps.kml", "w")
    cps_kml.write(cps_file)
    cps_file.close

  end

end ##fin de la gestion du cps
